#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BNO055.h>
#include <utility/imumaths.h>
#include <SPI.h>
#include <SD.h>
Adafruit_BNO055 bno = Adafruit_BNO055(55);
#define BNO055_SAMPLERATE_DELAY_MS (10)

// assign pins
const int chipSelect = 4;
const int buttonPin = 6;
int looprun;


// the logging file
File logfile;

void setup(void)
{
  Serial.begin(9600);
  //while (!Serial) ;
  pinMode(buttonPin, INPUT_PULLUP);
  Serial.print("Initializing SD card...");
  pinMode(4, OUTPUT);
  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    // don't do anything more:
    return;
  }
  Serial.println("card initialized.");
  Serial.println("Orientation Sensor Test"); Serial.println("");

  if (!bno.begin())
  {
    /* There was a problem detecting the BNO055 ... check your connections */
    Serial.print("Ooops, no BNO055 detected ... Check your wiring or I2C ADDR!");
    while (1);
  }
  delay(1000);
  bno.setExtCrystalUse(true);
  Serial.println("Exit Setup");
}

void loop(void)
{
  int buttonState;
  buttonState = digitalRead(buttonPin);
  if (buttonState == LOW) {
    Serial.println("Make File");
    looprun = 1;
    // create a new file
    char filename[] = "LOGGER00.csv";
    for (uint8_t i = 0; i < 100; i++) {
      filename[6] = i / 10 + '0';
      filename[7] = i % 10 + '0';
      if (! SD.exists(filename)) {
        // only open a new file if it doesn't exist
        logfile = SD.open(filename, FILE_WRITE);
        break;  // leave the loop!
      }
    }
    if (!logfile) {
      Serial.println("couldnt create file");
    }
    while (looprun == 1) {
      /* Get a new sensor event */
      sensors_event_t event;
      bno.getEvent(&event);
      digitalWrite(13, HIGH);
      //delay(100);
      imu::Vector<3> euler = bno.getVector(Adafruit_BNO055::VECTOR_LINEARACCEL);
          Serial.print("X:");
          Serial.print(event.orientation.x);
          Serial.print("Y:");
          Serial.print(event.orientation.y);
         Serial.print("Z:");
         Serial.print(event.orientation.z);
          Serial.print(" Time:");
          Serial.println(millis());
        logfile.print(",");
          logfile.print(event.orientation.x);
          logfile.print(",");
          logfile.print(event.orientation.y);
          logfile.print(",");
          logfile.print(event.orientation.z);
          logfile.print(",");
      logfile.println(millis());
      logfile.print(",");
      buttonState = digitalRead(buttonPin);
      if (buttonState == LOW) {
        delay(50);
        buttonState = digitalRead(buttonPin);
        if (buttonState == LOW) {
          logfile.close();
          digitalWrite(13, LOW);
          delay(1000);
          looprun = 0;
        }
      }
    }
  }
}
